<html lang="en">
<head>
<title>Making New Objects - Enhanced Implementation of Emacs Interpreted Objects</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Enhanced Implementation of Emacs Interpreted Objects">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="prev" href="Default-Superclass.html#Default-Superclass" title="Default Superclass">
<link rel="next" href="Accessing-Slots.html#Accessing-Slots" title="Accessing Slots">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Making-New-Objects"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="Accessing-Slots.html#Accessing-Slots">Accessing Slots</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Default-Superclass.html#Default-Superclass">Default Superclass</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="index.html#Top">Top</a>
<hr>
</div>

<!-- node-name,  next,  previous,  up -->
<h2 class="chapter">5 Making New Objects</h2>

<p>Once we have defined our classes, it's time to create objects with the
specified structure.  After we call <code>defclass</code> two new functions
are created, one of which is <code>classname</code>.  Thus, from the example at
the end of the previous chapter See <a href="Building-Classes.html#Building-Classes">Building Classes</a>, we would have
the functions <code>data-object</code> and <code>data-object-p</code>.

<div class="defun">
&mdash; Function: <b>classname</b><var> object-name &amp;rest slots<a name="index-classname-13"></a></var><br>
<blockquote>
<p>This creates and returns a new object.  This object is not assigned to
anything, and will be garbage collected if not saved.  This object will
be given the string name <var>object-name</var>.  There can be multiple
objects of the same name, but the name slot provides a handy way to
keep track of your objects.  <var>slots</var> is just all the slots you
wish to preset.  Any slot set as such WILL NOT get it's default value,
and any side effects from an attributes default function will not occur. 
An example pair would appear simply as <code>:value 1</code>.  Of course you
can do any valid lispy thing you want with it, such as
<code>:value (if (boundp 'special-symbol) special-symbol nil)</code>

        <p>Example of creating an object from a class, <a href="Building-Classes.html#Building-Classes">Building Classes</a>:

     <pre class="example">          (data-object "test" :value 3 :reference nil)
     </pre>
        </blockquote></div>

   </body></html>

